/*FASE-1*/
/*
 * 1.Creo il database
 */
CREATE DATABASE `scuola_in_chiaro1`;
/*
 * Pongo in uso il database
 */ 
USE `scuola_in_chiaro1`;
/*
 * 2.Creo la tabella scuole.
 */
CREATE TABLE `scuole` (
	`pk_scuola` CHAR(10) NOT NULL COMMENT 'Codice scuola',
	`denominazione` VARCHAR(90) NULL DEFAULT NULL COMMENT 'Denominazione dell\'istituto',
	`des_tipo_scuola` VARCHAR(40) NOT NULL COMMENT 'Tipologia istituto - denominazione',
	`indirizzo` VARCHAR(60) NULL DEFAULT NULL COMMENT 'Indirizzo (Via + numero civico)',
	`comune` VARCHAR(50) NULL DEFAULT NULL COMMENT 'Indirizzo (Comune) - denominazione',
	`cap` CHAR(5) NULL DEFAULT NULL COMMENT 'Indirizzo (CAP)',
	`telefono` VARCHAR(20) NULL DEFAULT NULL COMMENT 'Telefono',
	`fax` VARCHAR(20) NULL DEFAULT NULL COMMENT 'Fax',
	`email` VARCHAR(60) NULL DEFAULT NULL COMMENT 'email',
	`pec` VARCHAR(60) NULL DEFAULT NULL COMMENT 'email - PEC',
	`sito_web` VARCHAR(70) NULL DEFAULT NULL COMMENT 'Sito web',
	`cod_istituto_principale` CHAR(10) NOT NULL COMMENT 'Istituto principale di riferimento (sede direzione)',
	`statale` VARCHAR(10) NOT NULL COMMENT 'Tipo di scuola (statale, paritaria)',
	`latitudine` VARCHAR(10) NULL DEFAULT NULL COMMENT 'Coordinata latitudine',
	`longitudine` VARCHAR(10) NULL DEFAULT NULL COMMENT 'Coordinata longitudine',
	PRIMARY KEY (`pk_scuola`)
)
COMMENT='Anagrafica degli Istituti scolastici'
ENGINE=InnoDB;
/*
 * 3.Carico i dati dal file Anagrafica.csv nella tabella anagrafiche
 * T4T -> Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\Anagrafica.csv
 * Windows -> C:\\Users\\mgm\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\Anagrafica.csv
 * Linux&Wine -> Z:home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/Anagrafica.csv
 * Linux -> /home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/Anagrafica.csv
 */
LOAD DATA LOW_PRIORITY LOCAL INFILE 'Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\Anagrafica.csv' 
INTO TABLE `scuola_in_chiaro1`.`scuole` FIELDS TERMINATED BY '|' OPTIONALLY ENCLOSED BY '"' ESCAPED BY '"' LINES TERMINATED BY 
'\r\n' IGNORE 1 LINES (`pk_scuola`, `denominazione`, `des_tipo_scuola`, `indirizzo`,`comune`, `cap`, `telefono`, `fax`, 
`email`, `pec`,`sito_web`, `cod_istituto_principale`, `statale`, `latitudine`, `longitudine`);
/*
 * 4.Impongo a NULL tutte le istanze degli attributi in scuole che non abbiano valori assegnati
 */
UPDATE `scuola_in_chiaro1`.`scuole` SET `pk_scuola`= NULL WHERE `pk_scuola`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `denominazione`= NULL WHERE `denominazione`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `des_tipo_scuola`= NULL WHERE `des_tipo_scuola`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `indirizzo`= NULL WHERE `indirizzo`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `comune`= NULL WHERE `comune`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `cap`= NULL WHERE `cap`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `telefono`= NULL WHERE `telefono`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `fax`= NULL WHERE `fax`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `email`= NULL WHERE `email`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `pec`= NULL WHERE `pec`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `sito_web`= NULL WHERE `sito_web`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `cod_istituto_principale`= NULL WHERE `cod_istituto_principale`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `statale`= NULL WHERE `statale`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `latitudine`= NULL WHERE `latitudine`= '';
UPDATE `scuola_in_chiaro1`.`scuole` SET `longitudine`= NULL WHERE `longitudine`= '';
/*
 * 5.Creo la tabella atta a contenere i dati del file csv delle attrezzature multimediali
 */
create table attrezzature_mult(
	fk_scuola char(10) not null COMMENT 'Codice scuola',
	pc_desktop smallint(6) not null COMMENT 'n° di pc desktop',
	pc_laptop smallint(6) not null COMMENT 'n° di pc laptop',
	lim_aula smallint(6) not null COMMENT 'n° di aule con lim',
	lim_laboratorio smallint(6) not null COMMENT 'n° di laboratori con lim',
	lim_mobili smallint(6) not null COMMENT 'n° di lim mobili',
	paule_lan varchar(4) not null COMMENT '% di aule in rete LAN',
	paule_wifi varchar(4) not null COMMENT '% di aule in rete WI-FI',
	primary key (fk_scuola),
	foreign key (fk_scuola) references scuole (pk_scuola)
)
COMMENT='Attrezzature multimediali'
ENGINE=InnoDB;
/*
 * 6.Carico i dati dal file attrzzature_mult.csv nella tabella attrezzature_mult
 * T4T -> Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\attrezzature_mult.csv
 * Windows -> C:\\Users\\mgm\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\attrezzature_mult.csv
 * Linux&Wine -> Z:home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/attrezzature_mult.csv
 * Linux -> /home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/attrezzature_mult.csv
 */
LOAD DATA LOW_PRIORITY LOCAL INFILE 'Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\attrezzature_mult.csv' 
INTO TABLE `scuola_in_chiaro1`.`attrezzature_mult` FIELDS TERMINATED BY '|' OPTIONALLY ENCLOSED BY '"' ESCAPED BY '"' 
LINES TERMINATED BY '\r\n' IGNORE 1 LINES (fk_scuola, pc_desktop, pc_laptop, lim_aula, lim_laboratorio, lim_mobili, 
paule_lan, paule_wifi);
/*
 * 7.Modifico le istanze di degli attributi paule_lan e paule_wifi della tabella attrezzature_mult cambiando la "," con il "."
 */
UPDATE scuola_in_chiaro1.attrezzature_mult SET paule_lan= REPLACE( paule_lan, ',' , '.');
UPDATE scuola_in_chiaro1.attrezzature_mult SET paule_wifi= REPLACE( paule_wifi, ',' , '.');
/*
 * 8.Cambio lo schema della tabella attrezzature_mult variando il tipo degli attributi paule_lan e paule_wifi da VARCHAR a FLOAT
 */
ALTER TABLE scuola_in_chiaro1.attrezzature_mult
	CHANGE COLUMN paule_lan paule_lan FLOAT not NULL,
	CHANGE COLUMN paule_wifi paule_wifi FLOAT not NULL;
