/*FASE-1*/
/*
 * 1.Creo il database
 */
CREATE DATABASE `scuola_in_chiaro2`;
/*
 * Pongo in uso il database
 */ 
USE `scuola_in_chiaro2`;
/*
 * 2.Creo la tabella scuole.
 */
CREATE TABLE `scuole` (
	`pk_scuola` CHAR(10) NOT NULL COMMENT 'Codice scuola',
	`denominazione` VARCHAR(90) NULL DEFAULT NULL COMMENT 'Denominazione dell\'istituto',
	`des_tipo_scuola` VARCHAR(40) NOT NULL COMMENT 'Tipologia istituto - denominazione',
	`indirizzo` VARCHAR(60) NULL DEFAULT NULL COMMENT 'Indirizzo (Via + numero civico)',
	`comune` VARCHAR(50) NULL DEFAULT NULL COMMENT 'Indirizzo (Comune) - denominazione',
	`cap` CHAR(5) NULL DEFAULT NULL COMMENT 'Indirizzo (CAP)',
	`telefono` VARCHAR(20) NULL DEFAULT NULL COMMENT 'Telefono',
	`fax` VARCHAR(20) NULL DEFAULT NULL COMMENT 'Fax',
	`email` VARCHAR(60) NULL DEFAULT NULL COMMENT 'email',
	`pec` VARCHAR(60) NULL DEFAULT NULL COMMENT 'email - PEC',
	`sito_web` VARCHAR(70) NULL DEFAULT NULL COMMENT 'Sito web',
	`cod_istituto_principale` CHAR(10) NOT NULL COMMENT 'Istituto principale di riferimento (sede direzione)',
	`statale` VARCHAR(10) NOT NULL COMMENT 'Tipo di scuola (statale, paritaria)',
	`latitudine` VARCHAR(10) NULL DEFAULT NULL COMMENT 'Coordinata latitudine',
	`longitudine` VARCHAR(10) NULL DEFAULT NULL COMMENT 'Coordinata longitudine',
	PRIMARY KEY (`pk_scuola`)
)
COMMENT='Anagrafica degli Istituti scolastici'
ENGINE=InnoDB;
/*
 * 3.Carico i dati dal file Anagrafica.csv nella tabella anagrafiche
 * T4T -> Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\Anagrafica.csv
 * Windows -> C:\\Users\\mgm\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\Anagrafica.csv
 * Linux&Wine -> Z:home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/Anagrafica.csv
 * Linux -> /home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/Anagrafica.csv
 */
LOAD DATA LOW_PRIORITY LOCAL INFILE 'Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\Anagrafica.csv' 
INTO TABLE `scuola_in_chiaro2`.`scuole` FIELDS TERMINATED BY '|' OPTIONALLY ENCLOSED BY '"' ESCAPED BY '"' LINES TERMINATED BY 
'\r\n' IGNORE 1 LINES (`pk_scuola`, `denominazione`, `des_tipo_scuola`, `indirizzo`,`comune`, `cap`, `telefono`, `fax`, 
`email`, `pec`,`sito_web`, `cod_istituto_principale`, `statale`, `latitudine`, `longitudine`);
/*
 * 4.Impongo a NULL tutte le istanze degli attributi in scuole che non abbiano valori assegnati
 */
UPDATE `scuola_in_chiaro2`.`scuole` SET `pk_scuola`= NULL WHERE `pk_scuola`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `denominazione`= NULL WHERE `denominazione`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `des_tipo_scuola`= NULL WHERE `des_tipo_scuola`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `indirizzo`= NULL WHERE `indirizzo`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `comune`= NULL WHERE `comune`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `cap`= NULL WHERE `cap`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `telefono`= NULL WHERE `telefono`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `fax`= NULL WHERE `fax`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `email`= NULL WHERE `email`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `pec`= NULL WHERE `pec`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `sito_web`= NULL WHERE `sito_web`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `cod_istituto_principale`= NULL WHERE `cod_istituto_principale`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `statale`= NULL WHERE `statale`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `latitudine`= NULL WHERE `latitudine`= '';
UPDATE `scuola_in_chiaro2`.`scuole` SET `longitudine`= NULL WHERE `longitudine`= '';
/*
 * 5.Creo la tabella atta a contenere i dati del file csv delle attrezzature multimediali
 */
create table attrezzature_mult(
	fk_scuola char(10) not null COMMENT 'Codice scuola',
	pc_desktop smallint(6) not null COMMENT 'n° di pc desktop',
	pc_laptop smallint(6) not null COMMENT 'n° di pc laptop',
	lim_aula smallint(6) not null COMMENT 'n° di aule con lim',
	lim_laboratorio smallint(6) not null COMMENT 'n° di laboratori con lim',
	lim_mobili smallint(6) not null COMMENT 'n° di lim mobili',
	paule_lan varchar(4) not null COMMENT '% di aule in rete LAN',
	paule_wifi varchar(4) not null COMMENT '% di aule in rete WI-FI',
	primary key (fk_scuola),
	foreign key (fk_scuola) references scuole (pk_scuola)
)
COMMENT='Attrezzature multimediali'
ENGINE=InnoDB;
/*
 * 6.Carico i dati dal file attrzzature_mult.csv nella tabella attrezzature_mult
 * T4T -> Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\attrezzature_mult.csv
 * Windows -> C:\\Users\\mgm\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\attrezzature_mult.csv
 * Linux&Wine -> Z:home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/attrezzature_mult.csv
 * Linux -> /home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/attrezzature_mult.csv
 */
LOAD DATA LOW_PRIORITY LOCAL INFILE 'Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\attrezzature_mult.csv' 
INTO TABLE `scuola_in_chiaro2`.`attrezzature_mult` FIELDS TERMINATED BY '|' OPTIONALLY ENCLOSED BY '"' ESCAPED BY '"' 
LINES TERMINATED BY '\r\n' IGNORE 1 LINES (fk_scuola, pc_desktop, pc_laptop, lim_aula, lim_laboratorio, lim_mobili, 
paule_lan, paule_wifi);
/*
 * 7.Modifico le istanze di degli attributi paule_lan e paule_wifi della tabella attrezzature_mult cambiando la "," con il "."
 */
UPDATE scuola_in_chiaro2.attrezzature_mult SET paule_lan= REPLACE( paule_lan, ',' , '.');
UPDATE scuola_in_chiaro2.attrezzature_mult SET paule_wifi= REPLACE( paule_wifi, ',' , '.');
/*
 * 8.Cambio lo schema della tabella attrezzature_mult variando il tipo degli attributi paule_lan e paule_wifi da VARCHAR a FLOAT
 */
ALTER TABLE scuola_in_chiaro2.attrezzature_mult
	CHANGE COLUMN paule_lan paule_lan FLOAT not NULL,
	CHANGE COLUMN paule_wifi paule_wifi FLOAT not NULL;
/*FASE-2*/
/*
 * 1.Creo la tabella attrezzature atta a contenere tutte le attrezzature scolastiche, per ora solo quella multimediale
 */
create table attrezzature (
	pk_attrezzatura varchar(60) not null COMMENT 'Descrizione attrezzatura',
	primary key (pk_attrezzatura)
)
COMMENT='Attrezzature'
ENGINE=InnoDB;
/*
 * 2.Popolo la tabella attrezzature; per comodità implementativa utilizzo i nomi delle colonne del file attrezzature_mult.csv
 */
insert into attrezzature (pk_attrezzatura) values ('pc_desktop'),('pc_laptop'),('lim_aula'),('lim_laboratorio'),('lim_mobili'),
	('paule_lan'),('paule_wifi');
/*
 * 3.Creo la tabella dotazioni che risolve la relazione molti-a-molti fra la tabella scuole e la tabella attrezzature
 * e contenete anche le quantità o le percentuali riportate nel file attrezzature_mult.csv per ogni tipo di attrezzatura
 */
create table dotazioni (
	fk_scuola char(10) not null COMMENT 'Codice scuola',
	fk_attrezzatura varchar(60) not null COMMENT 'Descrizione attrezzatura',
	valore float not null COMMENT 'Quantità/Percentuale',
	primary key (fk_scuola, fk_attrezzatura),
	foreign key (fk_scuola) references scuole (pk_scuola),
	foreign key (fk_attrezzatura) references attrezzature (pk_attrezzatura)
)
COMMENT='Dotazioni'
ENGINE=InnoDB;
/*
 * 4.Fase di popolamento della tabella dotazioni utilizzando una tabella temporanea appoggio e la tabella attrezzature.
 * Ho evitato istruzioni di ciclo e condizionali perché non credo vengano viste a scuola.
 * Non sarà elegante ma serve allo scopo.
 */
/*
 * pc_desktop
 */
create temporary table appoggio engine=innodb
	select fk_scuola, pc_desktop from attrezzature_mult where pc_desktop <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.pc_desktop as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'pc_desktop';
		
drop table appoggio;
/*
 * pc_laptop
 */
create temporary table appoggio engine=innodb
	select fk_scuola, pc_laptop from attrezzature_mult where pc_laptop <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.pc_laptop as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'pc_laptop';
		
drop table appoggio;
/*
 * lim_aula
 */
create temporary table appoggio engine=innodb
	select fk_scuola, lim_aula from attrezzature_mult where lim_aula <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.lim_aula as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'lim_aula';
		
drop table appoggio;
/*
 * lim_laboratorio
 */
create temporary table appoggio engine=innodb
	select fk_scuola, lim_laboratorio from attrezzature_mult where lim_laboratorio <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.lim_laboratorio as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'lim_laboratorio';
		
drop table appoggio;
/*
 * lim_mobili
 */
create temporary table appoggio engine=innodb
	select fk_scuola, lim_mobili from attrezzature_mult where lim_mobili <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.lim_mobili as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'lim_mobili';
		
drop table appoggio;
/*
 * paule_lan
 */
create temporary table appoggio engine=innodb
	select fk_scuola, paule_lan from attrezzature_mult where paule_lan <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.paule_lan as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'paule_lan';
		
drop table appoggio;
/*
 * paule_wifi
 */
create temporary table appoggio engine=innodb
	select fk_scuola, paule_wifi from attrezzature_mult where paule_wifi <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.paule_wifi as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'paule_wifi';
		
drop table appoggio;
/*
 * 5.Elimino la tabella attrezzature_mult non servendo più
 */
drop table attrezzature_mult;


