/*FASE-1*/
/*
 * 1.Creo il database
 */
CREATE DATABASE `scuola_in_chiaro5`;
/*
 * Pongo in uso il database
 */ 
USE `scuola_in_chiaro5`;
/*
 * 2.Creo la tabella scuole.
 */
CREATE TABLE `scuole` (
	`pk_scuola` CHAR(10) NOT NULL COMMENT 'Codice scuola',
	`denominazione` VARCHAR(90) NULL DEFAULT NULL COMMENT 'Denominazione dell\'istituto',
	`des_tipo_scuola` VARCHAR(40) NOT NULL COMMENT 'Tipologia istituto - denominazione',
	`indirizzo` VARCHAR(60) NULL DEFAULT NULL COMMENT 'Indirizzo (Via + numero civico)',
	`comune` VARCHAR(50) NULL DEFAULT NULL COMMENT 'Indirizzo (Comune) - denominazione',
	`cap` CHAR(5) NULL DEFAULT NULL COMMENT 'Indirizzo (CAP)',
	`telefono` VARCHAR(20) NULL DEFAULT NULL COMMENT 'Telefono',
	`fax` VARCHAR(20) NULL DEFAULT NULL COMMENT 'Fax',
	`email` VARCHAR(60) NULL DEFAULT NULL COMMENT 'email',
	`pec` VARCHAR(60) NULL DEFAULT NULL COMMENT 'email - PEC',
	`sito_web` VARCHAR(70) NULL DEFAULT NULL COMMENT 'Sito web',
	`cod_istituto_principale` CHAR(10) NOT NULL COMMENT 'Istituto principale di riferimento (sede direzione)',
	`statale` VARCHAR(10) NOT NULL COMMENT 'Tipo di scuola (statale, paritaria)',
	`latitudine` VARCHAR(10) NULL DEFAULT NULL COMMENT 'Coordinata latitudine',
	`longitudine` VARCHAR(10) NULL DEFAULT NULL COMMENT 'Coordinata longitudine',
	PRIMARY KEY (`pk_scuola`)
)
COMMENT='Anagrafica degli Istituti scolastici'
ENGINE=InnoDB;
/*
 * 3.Carico i dati dal file Anagrafica.csv nella tabella anagrafiche
 * T4T -> Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\Anagrafica.csv
 * Windows -> C:\\Users\\mgm\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\Anagrafica.csv
 * Linux&Wine -> Z:home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/Anagrafica.csv
 * Linux -> /home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/Anagrafica.csv
 */
LOAD DATA LOW_PRIORITY LOCAL INFILE 'Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\Anagrafica.csv' 
INTO TABLE `scuola_in_chiaro5`.`scuole` FIELDS TERMINATED BY '|' OPTIONALLY ENCLOSED BY '"' ESCAPED BY '"' LINES TERMINATED BY 
'\r\n' IGNORE 1 LINES (`pk_scuola`, `denominazione`, `des_tipo_scuola`, `indirizzo`,`comune`, `cap`, `telefono`, `fax`, 
`email`, `pec`,`sito_web`, `cod_istituto_principale`, `statale`, `latitudine`, `longitudine`);
/*
 * 4.Impongo a NULL tutte le istanze degli attributi in scuole che non abbiano valori assegnati
 */
UPDATE `scuola_in_chiaro5`.`scuole` SET `pk_scuola`= NULL WHERE `pk_scuola`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `denominazione`= NULL WHERE `denominazione`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `des_tipo_scuola`= NULL WHERE `des_tipo_scuola`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `indirizzo`= NULL WHERE `indirizzo`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `comune`= NULL WHERE `comune`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `cap`= NULL WHERE `cap`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `telefono`= NULL WHERE `telefono`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `fax`= NULL WHERE `fax`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `email`= NULL WHERE `email`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `pec`= NULL WHERE `pec`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `sito_web`= NULL WHERE `sito_web`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `cod_istituto_principale`= NULL WHERE `cod_istituto_principale`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `statale`= NULL WHERE `statale`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `latitudine`= NULL WHERE `latitudine`= '';
UPDATE `scuola_in_chiaro5`.`scuole` SET `longitudine`= NULL WHERE `longitudine`= '';
/*
 * 5.Creo la tabella atta a contenere i dati del file csv delle attrezzature multimediali
 */
create table attrezzature_mult(
	fk_scuola char(10) not null COMMENT 'Codice scuola',
	pc_desktop smallint(6) not null COMMENT 'n° di pc desktop',
	pc_laptop smallint(6) not null COMMENT 'n° di pc laptop',
	lim_aula smallint(6) not null COMMENT 'n° di aule con lim',
	lim_laboratorio smallint(6) not null COMMENT 'n° di laboratori con lim',
	lim_mobili smallint(6) not null COMMENT 'n° di lim mobili',
	paule_lan varchar(4) not null COMMENT '% di aule in rete LAN',
	paule_wifi varchar(4) not null COMMENT '% di aule in rete WI-FI',
	primary key (fk_scuola),
	foreign key (fk_scuola) references scuole (pk_scuola)
)
COMMENT='Attrezzature multimediali'
ENGINE=InnoDB;
/*
 * 6.Carico i dati dal file attrzzature_mult.csv nella tabella attrezzature_mult
 * T4T -> Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\attrezzature_mult.csv
 * Windows -> C:\\Users\\mgm\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\attrezzature_mult.csv
 * Linux&Wine -> Z:home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/attrezzature_mult.csv
 * Linux -> /home/mgm/Scrivania/scuolaInChiaro/alunni/Anagrafe/attrezzature_mult.csv
 */
LOAD DATA LOW_PRIORITY LOCAL INFILE 'Z:\\Desktop\\scuolaInChiaro\\alunni\\Anagrafe\\attrezzature_mult.csv' 
INTO TABLE `scuola_in_chiaro5`.`attrezzature_mult` FIELDS TERMINATED BY '|' OPTIONALLY ENCLOSED BY '"' ESCAPED BY '"' 
LINES TERMINATED BY '\r\n' IGNORE 1 LINES (fk_scuola, pc_desktop, pc_laptop, lim_aula, lim_laboratorio, lim_mobili, 
paule_lan, paule_wifi);
/*
 * 7.Modifico le istanze di degli attributi paule_lan e paule_wifi della tabella attrezzature_mult cambiando la "," con il "."
 */
UPDATE scuola_in_chiaro5.attrezzature_mult SET paule_lan= REPLACE( paule_lan, ',' , '.');
UPDATE scuola_in_chiaro5.attrezzature_mult SET paule_wifi= REPLACE( paule_wifi, ',' , '.');
/*
 * 8.Cambio lo schema della tabella attrezzature_mult variando il tipo degli attributi paule_lan e paule_wifi da VARCHAR a FLOAT
 */
ALTER TABLE scuola_in_chiaro5.attrezzature_mult
	CHANGE COLUMN paule_lan paule_lan FLOAT not NULL,
	CHANGE COLUMN paule_wifi paule_wifi FLOAT not NULL;
/*FASE-2*/
/*
 * 1.Creo la tabella attrezzature atta a contenere tutte le attrezzature scolastiche, per ora solo quella multimediale
 */
create table attrezzature (
	pk_attrezzatura varchar(60) not null COMMENT 'Descrizione attrezzatura',
	primary key (pk_attrezzatura)
)
COMMENT='Attrezzature'
ENGINE=InnoDB;
/*
 * 2.Popolo la tabella attrezzature; per comodità implementativa utilizzo i nomi delle colonne del file attrezzature_mult.csv
 */
insert into attrezzature (pk_attrezzatura) values ('pc_desktop'),('pc_laptop'),('lim_aula'),('lim_laboratorio'),('lim_mobili'),
	('paule_lan'),('paule_wifi');
/*
 * 3.Creo la tabella dotazioni che risolve la relazione molti-a-molti fra la tabella scuole e la tabella attrezzature
 * e contenete anche le quantità o le percentuali riportate nel file attrezzature_mult.csv per ogni tipo di attrezzatura
 */
create table dotazioni (
	fk_scuola char(10) not null COMMENT 'Codice scuola',
	fk_attrezzatura varchar(60) not null COMMENT 'Descrizione attrezzatura',
	valore float not null COMMENT 'Quantità/Percentuale',
	primary key (fk_scuola, fk_attrezzatura),
	foreign key (fk_scuola) references scuole (pk_scuola),
	foreign key (fk_attrezzatura) references attrezzature (pk_attrezzatura)
)
COMMENT='Dotazioni'
ENGINE=InnoDB;
/*
 * 4.Fase di popolamento della tabella dotazioni utilizzando una tabella temporanea appoggio e la tabella attrezzature.
 * Ho evitato istruzioni di ciclo e condizionali perché non credo vengano viste a scuola.
 * Non sarà elegante ma serve allo scopo.
 */
/*
 * pc_desktop
 */
create temporary table appoggio engine=innodb
	select fk_scuola, pc_desktop from attrezzature_mult where pc_desktop <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.pc_desktop as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'pc_desktop';
		
drop table appoggio;
/*
 * pc_laptop
 */
create temporary table appoggio engine=innodb
	select fk_scuola, pc_laptop from attrezzature_mult where pc_laptop <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.pc_laptop as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'pc_laptop';
		
drop table appoggio;
/*
 * lim_aula
 */
create temporary table appoggio engine=innodb
	select fk_scuola, lim_aula from attrezzature_mult where lim_aula <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.lim_aula as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'lim_aula';
		
drop table appoggio;
/*
 * lim_laboratorio
 */
create temporary table appoggio engine=innodb
	select fk_scuola, lim_laboratorio from attrezzature_mult where lim_laboratorio <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.lim_laboratorio as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'lim_laboratorio';
		
drop table appoggio;
/*
 * lim_mobili
 */
create temporary table appoggio engine=innodb
	select fk_scuola, lim_mobili from attrezzature_mult where lim_mobili <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.lim_mobili as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'lim_mobili';
		
drop table appoggio;
/*
 * paule_lan
 */
create temporary table appoggio engine=innodb
	select fk_scuola, paule_lan from attrezzature_mult where paule_lan <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.paule_lan as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'paule_lan';
		
drop table appoggio;
/*
 * paule_wifi
 */
create temporary table appoggio engine=innodb
	select fk_scuola, paule_wifi from attrezzature_mult where paule_wifi <> 0;

insert into dotazioni (fk_scuola, fk_attrezzatura, valore)
	select appoggio.fk_scuola, attrezzature.pk_attrezzatura as fk_attrezzatura, appoggio.paule_wifi as valore
		from appoggio, attrezzature
		where attrezzature.pk_attrezzatura = 'paule_wifi';
		
drop table appoggio;
/*
 * 5.Elimino la tabella attrezzature_mult non servendo più
 */
drop table attrezzature_mult;
/*FASE-3*/
/*
 * 1.Creo la tabella atta a contenere i dati del file csv delle regioni e delle province (ISTAT) che sarà eliminata
 * una volta concluse le operazioni di creazione delle tabelle delle regioni e delle province
 */
CREATE TABLE `regioni_province_istat` (
	`Codice_ripartizione` TINYINT(1) NOT NULL,
	`Codice_NUTS1_2006` CHAR(3) NOT NULL,
	`Codice_NUTS1_2010` CHAR(3) NOT NULL,
	`Ripartizione_geografica_Maiuscolo` VARCHAR(10) NOT NULL,
	`Ripartizione_geografica` VARCHAR(10) NOT NULL,
	`Codice_regione` SMALLINT NOT NULL,
	`Codice_NUTS2_2006_a` VARCHAR(4) NOT NULL,
	`Codice_NUTS2_2010_a` VARCHAR(4) NOT NULL,
	`Denominazione_regione_Maiuscolo` VARCHAR(28) NOT NULL,
	`Denominazione_regione` VARCHAR(28) NOT NULL,
	`Codice_provincia` SMALLINT(3) NOT NULL,
	`Codice_NUTS3_2006` VARCHAR(5) NOT NULL,
	`Codice_NUTS3_2010` VARCHAR(5) NOT NULL,
	`Denominazione_provincia` VARCHAR(28) NOT NULL,
	`Sigla_automobilistica` VARCHAR(2) NOT NULL
)
ENGINE=InnoDB;
/*
 * Carico i dati dal file ripartizioni_regioni_province.csv nella tabella regioni_province_istat
 * T4T -> Z:\\Desktop\\scuolaInChiaro\\regioni_province_comuni\\ripartizioni_regioni_province.csv
 * Windows -> C:\\Users\\mgm\\Desktop\\scuolaInChiaro\\regioni_province_comuni\\ripartizioni_regioni_province.csv
 * Linux&Wine -> Z:home/mgm/Scrivania/scuolaInChiaro/regioni_province_comuni/ripartizioni_regioni_province.csv
 * Linux -> /home/mgm/Scrivania/scuolaInChiaro/regioni_province_comuni/ripartizioni_regioni_province.csv
 * Potrebbe seganlare un errore perché alcune righe non sono terminate correttamente, ma dovrebbe caricare tutto.
 */
LOAD DATA LOW_PRIORITY LOCAL INFILE 'Z:\\Desktop\\scuolaInChiaro\\regioni_province_comuni\\ripartizioni_regioni_province.csv' 
INTO TABLE `scuola_in_chiaro5`.`regioni_province_istat` FIELDS TERMINATED BY ';' OPTIONALLY ENCLOSED BY '"' ESCAPED BY '"' 
LINES TERMINATED BY '\n' IGNORE 3 LINES (`Codice_ripartizione`,`Codice_NUTS1_2006`,`Codice_NUTS1_2010`,`Ripartizione_geografica_Maiuscolo`,
`Ripartizione_geografica`,`Codice_regione`,`Codice_NUTS2_2006_a`,`Codice_NUTS2_2010_a`,`Denominazione_regione_Maiuscolo`,`Denominazione_regione`,
`Codice_provincia`,`Codice_NUTS3_2006`,`Codice_NUTS3_2010`,`Denominazione_provincia`,`Sigla_automobilistica`);
/*
 * 2.Creo la tabella regioni derivandola dalla tabella regioni_province_istat
 */
create table regioni engine=innodb
	select distinct Codice_regione as pk_regione, Denominazione_regione as denominazione_regione,
	Ripartizione_geografica as ripartizione_geografica
	from regioni_province_istat;
/*
 * Modifico lo schema della tabella regioni creando la chiave primaria
 */
ALTER TABLE regioni
	ADD PRIMARY KEY (pk_regione);
/*
 * 3.Creo la tabella province derivandola dalla tabella regioni_province_istat e regioni
 */
create table province engine=innodb
	select regioni_province_istat.Codice_provincia as pk_provincia,
	regioni_province_istat.Denominazione_provincia as denominazione_provincia,
	regioni_province_istat.Sigla_automobilistica as sigla_automobilistica,
	regioni.pk_regione as fk_regione
	from regioni_province_istat, regioni
	where regioni_province_istat.Codice_regione = regioni.pk_regione;
/*
 * Modifico lo schema della tabella province creando la chiave primaria e la chiave esterna
 */
ALTER TABLE province
	ADD PRIMARY KEY (pk_provincia),
	ADD INDEX fk_regione (fk_regione),
	ADD CONSTRAINT fk_regione FOREIGN KEY (fk_regione) REFERENCES regioni (pk_regione);
/*
 * 4.Elimino la tabella regioni_province_istat che non serve più
 */
drop table regioni_province_istat;
/*
 * 6.Crea la tabella atta a contenere i dati del file csv dei comuni (ISTAT) che sarà eliminata
 * una volta concluse le operazioni di creazione della tabella dei comuni
 */
CREATE TABLE `comuni_istat` (
	`Ripartizione_geografica` VARCHAR(10) NOT NULL,
	`Codice_NUTS2_2010` VARCHAR(4) NOT NULL,
	`Codice_NUTS3_2010` VARCHAR(5) NOT NULL,
	`Codice_Regione` SMALLINT(6) NOT NULL,
	`Codice_Provincia` SMALLINT(6) NOT NULL,
	`Codice_Comune` SMALLINT(6) NOT NULL,
	`Codice_Istat_del_Comune_formato_alfanumerico` VARCHAR(6) NOT NULL,
	`Codice_Istat_del_Comune_formato_numerico` MEDIUMINT(9) NOT NULL,
	`Codice_Istat_del_Comune_a_103_province_formato_numerico` MEDIUMINT(9) NOT NULL,
	`Codice_Istat_del_Comune_a_107_province_formato_numerico` MEDIUMINT(9) NOT NULL,
	`Codice_Catastale` VARCHAR(4) NOT NULL,
	`Solo_denominazione_in_italiano` VARCHAR(35) NOT NULL,
	`Solo_denominazione_in_tedesco` VARCHAR(36) NOT NULL,
	`Comune_capoluogo_di_provincia` TINYINT(4) NOT NULL,
	`Zona_altimetrica` TINYINT(4) NOT NULL,
	`Altitudine_del_centro_metri` SMALLINT(6) NOT NULL,
	`Comune_litoraneo` TINYINT(4) NOT NULL,
	`Comune_Montano` VARCHAR(2) NOT NULL,
	`Codice_Sistema_locale_del_lavoro_2001` SMALLINT(6) NOT NULL,
	`Denominazione_Sistema_locale_del_lavoro_2001` VARCHAR(49) NOT NULL,
	`Superficie_territoriale_totale_kmq_al_09_10_2011` VARCHAR(9) NOT NULL,
	`Popolazione_legale_2001_21_10_2001` VARCHAR(7) NOT NULL,
	`Popolazione_legale_2011_09_10_2011` VARCHAR(7) NOT NULL
)
ENGINE=InnoDB;
/*
 * Carico i dati dal file elenco_ comuni_italiani_30 giugno_2013.csv nella tabella comuni
 * T4T -> Z:\\Desktop\\scuolaInChiaro\\regioni_province_comuni\\elenco_comuni_italiani_no_accento.csv
 * Windows -> C:\\Users\\mgm\\Desktop\\scuolaInChiaro\\regioni_province_comuni\\elenco_comuni_italiani_no_accento.csv
 * Linux&Wine -> Z:home/mgm/Scrivania/scuolaInChiaro/regioni_province_comuni/elenco_comuni_italiani_no_accento.csv
 * Linux -> /home/mgm/Scrivania/scuolaInChiaro/regioni_province_comuni/elenco_comuni_italiani_no_accento.csv
 * Potrebbe segnalare un errore perché alcune righe non sono terminate correttamente, ma dovrebbe caricare tutto.
 */
LOAD DATA LOW_PRIORITY LOCAL INFILE 'Z:\\Desktop\\scuolaInChiaro\\regioni_province_comuni\\elenco_comuni_italiani_no_accento.csv' 
INTO TABLE `scuola_in_chiaro5`.`comuni_istat` FIELDS TERMINATED BY ';' OPTIONALLY ENCLOSED BY '"' ESCAPED BY '"' 
LINES TERMINATED BY '\n' IGNORE 5 LINES (
Ripartizione_geografica, Codice_NUTS2_2010, Codice_NUTS3_2010, Codice_Regione, Codice_Provincia, Codice_Comune, 
Codice_Istat_del_Comune_formato_alfanumerico, Codice_Istat_del_Comune_formato_numerico, Codice_Istat_del_Comune_a_103_province_formato_numerico, 
Codice_Istat_del_Comune_a_107_province_formato_numerico, Codice_Catastale, Solo_denominazione_in_italiano, Solo_denominazione_in_tedesco, 
Comune_capoluogo_di_provincia, Zona_altimetrica, Altitudine_del_centro_metri, Comune_litoraneo, Comune_Montano, Codice_Sistema_locale_del_lavoro_2001, 
Denominazione_Sistema_locale_del_lavoro_2001, Superficie_territoriale_totale_kmq_al_09_10_2011, Popolazione_legale_2001_21_10_2001, 
Popolazione_legale_2011_09_10_2011);
/*
 * 7.Modifico le istanze dell'attributo Popolazione_legale_2011_09_10_2011 eliminando il "."
 */
UPDATE scuola_in_chiaro5.comuni_istat SET Popolazione_legale_2011_09_10_2011 = REPLACE( Popolazione_legale_2011_09_10_2011, '.' , '');
/*
 * Cambio lo schema della tabella comuni_istat variando il tipo dell'attributo Popolazione_legale_2011_09_10_2011 da VARCHAR a INT
 */
ALTER TABLE scuola_in_chiaro5.comuni_istat
	CHANGE COLUMN Popolazione_legale_2011_09_10_2011 Popolazione_legale_2011_09_10_2011 int not NULL;
/*
 * 8.Creo la tabella comuni atta a contenere le istanze della tabella comuni_istat e province
 */
create table comuni (
	pk_comune SMALLINT(6) auto_increment COMMENT 'Codice comune', 
	denominazione_comune VARCHAR(35) NOT NULL COMMENT 'Denominazione comune', 
	popolazione_comune int not null  COMMENT 'Popolazione del comune', 
	fk_provincia SMALLINT(6) NOT NULL COMMENT 'Codice provincia', 
	primary key (pk_comune), 
	foreign key (fk_provincia) references province (pk_provincia)
)
COMMENT='Comuni'
engine=innodb;
/*
 * Popolo la tabella comuni
 */
insert into scuola_in_chiaro5.comuni (denominazione_comune, popolazione_comune, fk_provincia)
	select comuni_istat.Solo_denominazione_in_italiano,
		comuni_istat.Popolazione_legale_2011_09_10_2011,
		comuni_istat.Codice_Provincia 
	from comuni_istat;
/*
 * 9.Elimino la tabella comuni_istat che non serve più
 */
drop table comuni_istat;
/*
 * 10.Modifico lo schema della tabella scuole aggiungendo l'attributo fk_comune che diventerà la chiave esterna alla tabella comuni
 */	
ALTER TABLE scuole
	ADD COLUMN fk_comune SMALLINT(6) NOT NULL AFTER comune;
/*
 * Le istruzioni seguenti dovrebbero permettermi di caricare il codice del comune nell'attributo fk_comune della tabella scuole.
 * La tabella temporanea la uso solo come supporto per riempire successivamente l'attributo fk_comune che dovrebbe diventare la 
 * chiave esterna che mette in relazione scuole con comuni 
 */
create temporary table appoggio engine=innodb
	select distinct comuni.pk_comune, comuni.denominazione_comune
	from comuni;
/*
 * Modifico lo schema della tabella appoggio trasformando in chiave primaria l'attributo pk_comune e in chiave l'attributo
 * denominazione_comune
 * SENZA QUESTE MODIFICHE L'UPDATE SUCCESSIVO RICHIEDE CIRCA 15 MINUTI PER ESSERE ESEGUITO
 */
alter table appoggio
	ADD PRIMARY KEY (pk_comune),
	ADD INDEX denominazione_comune (denominazione_comune);
/*FASE-4*/
/*
 * 1.Modifico le istanze dell'attributo comune della tabella scuole dove è stato inserito un *. Questo permette
 * di aumentare i comuni che combaciano fra le tabelle scuole e istat
 */	
UPDATE scuole SET comune = REPLACE(comune, left(comune,50), left(comune, (instr(comune, '*') - 2)))
	where instr(comune, '*');
/*
 * (FASE-3).Carico l'attributo fk_comune di scuole attraverso l'attributo pk_comune di appoggio
 */
update scuole, appoggio
	set scuole.fk_comune = appoggio.pk_comune
	where scuole.comune = appoggio.denominazione_comune;
/*
 * (FASE-3).Elimino la tabella temporanea appoggio
 */
drop table appoggio;
/*FASE-5*/
/*
 * 4.Creo la tabella temporanea per gestire gli ultimi comuni da sistemare tramite il cile comuni_sistemati.csv
 */
create temporary table appoggio (
	pk_comune SMALLINT(6) not null,
	denominazione_scorretta VARCHAR(35) not null,
	denominazione_corretta VARCHAR(35) not null,
	index denominazione_scorretta (denominazione_scorretta),
	index denominazione_corretta (denominazione_corretta)
)
engine = innodb;
/*
 * Carico la tabella di appoggio con il contenuto del file comuni_sistemati.csv
 * T4T -> Z:\\Desktop\\scuolaInChiaro\\sviluppo\\fase-5\\comuni_sistemati.csv
 * Linux -> /home/mgm/Scrivania/scuolaInChiaro/sviluppo/fase-5/comuni_sistemati.csv
 */
LOAD DATA LOW_PRIORITY LOCAL INFILE 'Z:\\Desktop\\scuolaInChiaro\\sviluppo\\fase-5\\comuni_sistemati.csv' 
INTO TABLE appoggio FIELDS TERMINATED BY ',' OPTIONALLY ENCLOSED BY '"' ESCAPED BY '\\' 
LINES TERMINATED BY '\n' (denominazione_scorretta, denominazione_corretta);
/*
 * Modifico le istanze dell'attributo pk_comune della tabella appoggio recuperando i dati
 * dalla tabella comuni
 */
update appoggio, comuni
	set appoggio.pk_comune = comuni.pk_comune
	where appoggio.denominazione_corretta = comuni.denominazione_comune;
/*
 * 5.Carico l'attributo fk_comune di scuole attraverso l'attributo pk_comune di appoggio
 */
update scuole, appoggio
	set scuole.fk_comune = appoggio.pk_comune
	where scuole.comune = appoggio.denominazione_scorretta;
/*
 * Elimino la tabella temporanea appoggio
 */
drop table appoggio;
/*
 * 6.Modifico lo schema della tabella scuole trasformando l'attributo fk_comune in una chiave esterna alla tabella comuni.
 * QUESTA E' LA QUERY CHE FINORA NON HA FUNZIONATO.
 */
 alter table scuole	
	ADD INDEX fk_comune (fk_comune),
	ADD CONSTRAINT fk_comune FOREIGN KEY (fk_comune) REFERENCES comuni(pk_comune);
/*
 * Visualizzo tutti i comuni nella tabella scuole a cui non è stato possibile assegnare una chiave esterna, nel caso ce ne fossero
 */
select scuole.denominazione from scuole
	where scuole.fk_comune=0;
/*
 * Modifico lo schema della tabella scuole eliminando l'attributo comune
 */	
ALTER TABLE `scuole` DROP COLUMN `comune`;
